using System;
using System.Collections.Generic;
using System.Linq;
using System.Collections;
using System.Web;
using System.IO;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Text;
using System.Configuration;
using MySql.Data.MySqlClient;
using MySql.Data;
using CLS_BL;
using CLS_DL;
using CLS_PL;
using iTextSharp.text;
using iTextSharp.text.pdf;
using iTextSharp.text.html;
using iTextSharp.text.html.simpleparser;
using System.Web.UI.DataVisualization.Charting;
using System.Drawing.Printing;
using System.Drawing;
using System.Drawing.Text;


namespace SUNWEB
{
    public partial class LandingCustomize : System.Web.UI.Page
    {
        BL_ErrorLog ObjError = new BL_ErrorLog();
        BL_SELECT ObjSel = new BL_SELECT();
        BLCompany ObjBL = new BLCompany();
        PLCOMMON ObjPL = new PLCOMMON();
        BL_USER ObjUserBL = new BL_USER(); //This Object for All User and Page Related fuctions included 
        PLCUSTOMER ObjCustPL = new PLCUSTOMER();
        Int32 K = 0;
        Int32 L = 0;
        Int32 S = 0;
        string ConStr = ConfigurationManager.ConnectionStrings["ConMysql"].ConnectionString;
        string ConStr_Rds = ConfigurationManager.ConnectionStrings["ConRDS"].ConnectionString;
        string Curr_Date = System.DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
        string Curr_DateOnly = System.DateTime.Now.ToString("yyyy-MM-dd");
        DateTime MonthstartDt;
        DataSet ds = new DataSet();
        MYSQLDB ObjMain = new MYSQLDB();
        DataTable DT = new DataTable();
        DataTable Dt2 = new DataTable();
        DataTable DtLicense = new DataTable();
        DataTable DtSuperAdmin = new DataTable();
        DataTable DtMultiBranch = new DataTable();
        DataTable DtNormalUser = new DataTable();
        DataTable DTProductSale = new DataTable();
        MySqlCommand Cmdv = new MySqlCommand();
        // User Variables 
        string UserId = string.Empty;
        string UserName = string.Empty;
        string PortalTypeId = string.Empty;
        string cd_Id = string.Empty;
        string Datapath = string.Empty;
        string cd_BranchAlias = string.Empty;
        string IsMultiBranch = string.Empty;
        string IsSuperAdmin = string.Empty;
        string ActiveCallvalue = string.Empty;
        // License Variables ..
        string PID = string.Empty;
        string Page_Acess = string.Empty;
        string Read_Acess = string.Empty;
        string Write_Acess = string.Empty;
        string Isdowld_Acess = string.Empty;
        string Rcd_id = string.Empty;
        string RPortalid = string.Empty;
        string Useridvalue = string.Empty;
        string QueryCurr_Select = string.Empty;
        string L_MaxUserCnt = string.Empty;

        string L_LandingCustomize = string.Empty;
        string Branchidval = string.Empty;
        string BranchFullName = string.Empty;
        string Curr_BranchFullName = string.Empty;
        string Cmb_BranchName = string.Empty;

        string HQ = string.Empty;
        string Cm_id = string.Empty;
        string ISHQ = string.Empty;
        DataSet DS = new DataSet();
        string Vw_Chk = string.Empty;
        string IISAppName = string.Empty;

        string SPath = string.Empty;
        string ChkImagePath = string.Empty;

        protected void Page_Load(object sender, EventArgs e)
        {

            PID = "33";    // This is for Retail Payment Page 


            if (!IsPostBack)
            {
                txtStartDt.Text = Curr_DateOnly;
                txtEndDt.Text = Curr_DateOnly;
            }
            MonthstartDt = new DateTime(System.DateTime.Now.Year, System.DateTime.Now.Month, 1);
            if (Session["UserName"] == null)
            {
                Response.Redirect("Login.aspx");
            }
            if (((Convert.ToBoolean(Session["IsSuperAdmin"])) == true) && (Session["PortalTypeId"].ToString() == "") && ((Convert.ToBoolean(Session["IsMultiBranch"])) == true))
            {
                if (!IsPostBack)
                {
                    LoadBranchName4SuperAdmin();

                    string QueryCal = "select ActiveValue from portaldb.usermaster  where Userid=" + Session["UserId"].ToString() + " ";
                    ActiveCallvalue = ObjMain.ExecuteScalar(QueryCal);
                    if (ActiveCallvalue != " " || ActiveCallvalue != "Select Branch")
                    {
                        ActiveCall();
                    }
                }
            }
            else if (((Convert.ToBoolean(Session["IsSuperAdmin"])) == true) && (Session["PortalTypeId"].ToString() == ""))
            {
                if (!IsPostBack)
                {
                    LoadBranchName4SuperAdmin();
                }
                cd_BranchAlias = cmbBranches.SelectedItem.Text;
                //LoadInventoryListGrid(cd_BranchAlias, txtStartDt.Text, txtEndDt.Text);
            }
            else if (((Convert.ToBoolean(Session["IsMultiBranch"])) == true) && (Session["PortalTypeId"].ToString() == ""))
            {
                if (!IsPostBack)
                {
                    LoadBranchName();
                    ActiveCall();
                }
            }
            else if (((Session["PortalTypeId"].ToString() != "") || (Convert.ToBoolean(Session["IsSuperAdmin"])) == false) && ((Convert.ToBoolean(Session["IsMultiBranch"])) == false))
            {
                cmbBranches.Enabled = false;
                cmbBranches.Visible = false;

                Cm_id = ObjSel.GETcmid(Session["Cd_Id"].ToString());  // Get cm_id
                HQ = ObjSel.Get_HQ(Cm_id);     // Get the HQ Value
                Curr_BranchFullName = ObjSel.GetBranchFullName(HQ, Session["Branch_HQ"].ToString());
                lblBranchAliasName.ForeColor = System.Drawing.Color.DodgerBlue;
                lblBranchAliasName.Text = "Branch Name" + "&nbsp;" + "-" + "&nbsp;" + Curr_BranchFullName + "&nbsp; ";

                cd_BranchAlias = Session["Branch_HQ"].ToString();
                Datapath = Session["DataPath"].ToString();
                PortalTypeId = Session["PortalTypeId"].ToString();

                DT = ObjUserBL.GetPageRightsDetailsPid(Session["UserId"].ToString(), PID);
                if (DT.Rows.Count > 0)
                {
                    Page_Acess = DT.Rows[0]["Acess_status"].ToString();
                    Read_Acess = DT.Rows[0]["Read_Access"].ToString();
                    Write_Acess = DT.Rows[0]["Write_Access"].ToString();
                    Isdowld_Acess = DT.Rows[0]["IDwld_Access"].ToString();

                    Session["Page_Acess"] = Page_Acess;
                    Session["Read_Acess"] = Read_Acess;
                    Session["Write_Acess"] = Write_Acess;
                    Session["Isdowld_Acess"] = Isdowld_Acess;
                }
                if ((Session["L_LandingCustomize"].ToString() == "N") || (Session["Page_Acess"].ToString() == "N"))
                {
                    Response.Redirect("DeniedPage.aspx");
                }
                else
                {
                    // lblMsgTotalSelection.Text = "Item Sale  Between" + "&nbsp;&nbsp;&nbsp;&nbsp;" + txtStartDt.Text + "&nbsp;&nbsp;&nbsp;  and  &nbsp;&nbsp;&nbsp;" + txtEndDt.Text;
                    if (!IsPostBack)
                    {
                        if (Session["Isdowld_Acess"].ToString() == "N")
                        {
                            // btnExcel.Enabled = false;
                            Response.Write(@"<script language='javascript'>alert('No Access To download.')</script>");
                        }
                        else
                        {
                            btnGetReports.Visible = true;

                            if (cmbBranches.Visible == false)
                            {
                                //  BindGridview(Session["Branch_HQ"].ToString(), txtStartDt.Text, txtEndDt.Text);
                            }

                        }


                    }

                }

            }
            else
            {

            }


        }


        public void ActiveCall()
        {
            string QueryCal = "select ActiveValue from portaldb.usermaster  where Userid=" + Session["UserId"].ToString() + " ";
            ActiveCallvalue = ObjMain.ExecuteScalar(QueryCal);
            if (ActiveCallvalue == "")
            {
                ActiveCallvalue = ObjSel.GetFirstBranch(Session["Branch_HQ"].ToString());
            }


            ISHQ = ObjMain.ExecuteScalar("select BranchName from " + ActiveCallvalue + ".branches where Branchname='" + ActiveCallvalue + "' and branchID=1;");  //now 

            if (ISHQ != "")
            {
                ActiveCallvalue = ObjSel.GetFirstBranch(Session["Branch_HQ"].ToString());
                UPDATEBRANCH(ActiveCallvalue);
            }

            cd_BranchAlias = ActiveCallvalue;
            Curr_BranchFullName = ObjUserBL.GetBranchCurr_BranchVal(Session["Branch_HQ"].ToString(), Session["UserId"].ToString(), cd_BranchAlias);
            Cmb_BranchName = ObjUserBL.GetBranchRealValue(Session["Branch_HQ"].ToString(), Session["UserId"].ToString(), Curr_BranchFullName);  // This will Return BranchName( Actual Database Name )
            cmbBranches.Items.FindByText(Curr_BranchFullName).Selected = true;
            Branchidval = ObjUserBL.GetBranchIDbyName(ActiveCallvalue, ActiveCallvalue);
            if (Branchidval != "")
            {
                DT = ObjUserBL.GetPageRightsDetailsPIDNew(Session["UserId"].ToString(), PID, Branchidval);
            }
            else
            {
                DT = ObjUserBL.GetPageRightsDetailsPIDNew(Session["UserId"].ToString(), PID, Session["Fistbranch"].ToString());

            }
            if (DT.Rows.Count > 0)
            {
                Page_Acess = DT.Rows[0]["Acess_status"].ToString();
                Read_Acess = DT.Rows[0]["Read_Access"].ToString();
                Write_Acess = DT.Rows[0]["Write_Access"].ToString();
                Isdowld_Acess = DT.Rows[0]["IDwld_Access"].ToString();

                Session["Page_Acess"] = Page_Acess;
                Session["Read_Acess"] = Read_Acess;
                Session["Write_Acess"] = Write_Acess;
                Session["Isdowld_Acess"] = Isdowld_Acess;
            }
            Rcd_id = ObjMain.ExecuteScalar("select cd_id from portaldb.companydetails where cd_branchid=" + cmbBranches.SelectedItem.Value + " and cd_branchalias='" + ActiveCallvalue + "';");
            RPortalid = ObjMain.ExecuteScalar("select portaltypeid  from portaldb.invoicedetails where cd_id=" + Rcd_id + ";");
            DtLicense = ObjUserBL.GetLicenseDetails(RPortalid);
            if (DtLicense.Rows.Count > 0)
            {


                L_LandingCustomize = DtLicense.Rows[0]["LANDINGCUSTOMIZE"].ToString();
                Session["L_LandingCustomize"] = L_LandingCustomize;
            }
            if (Session["L_LandingCustomize"].ToString() == "N" || Session["Page_Acess"].ToString() == "N")
            {
                Response.Redirect("DeniedPage.aspx");
            }
            else
            {

                //btnExcel.Enabled = true;
                //lblMsgTotalSelection.Text = "Total Sale Selection Between" + "&nbsp;&nbsp;&nbsp;" + txtStartDt.Text + "&nbsp;&nbsp;&nbsp;  And &nbsp;&nbsp;&nbsp;" + txtEndDt.Text;
                cd_BranchAlias = cmbBranches.SelectedItem.Text;
                // BindGridview(ActiveCallvalue, txtStartDt.Text, txtEndDt.Text);
                System.Threading.Thread.Sleep(2000);

            }

        }


        public void LoadBranchName()
        {
            DtNormalUser = ObjUserBL.GetBranchOnLoginValues8(Session["Branch_HQ"].ToString(), Session["UserId"].ToString(), Session["CM_ID"].ToString());
            if (DtNormalUser.Rows.Count > 0)
            {
                cmbBranches.DataSource = DtNormalUser;
                cmbBranches.DataTextField = "branchfullname";
                cmbBranches.DataValueField = "Branchid";
                cmbBranches.DataBind();
                cmbBranches.Items.Insert(0, "Select Branch");
            }
        }
        public void LoadBranchName4SuperAdmin()
        {
            DtSuperAdmin = ObjUserBL.GetBranchOnSuperAdmin8(Session["Branch_HQ"].ToString(), Session["UserId"].ToString(), Session["CM_ID"].ToString());
            if (DtSuperAdmin.Rows.Count > 0)
            {
                cmbBranches.DataSource = DtSuperAdmin;
                cmbBranches.DataTextField = "branchfullname";
                cmbBranches.DataValueField = "Branchid";
                cmbBranches.DataBind();
                cmbBranches.Items.Insert(0, "Select Branch");
            }
        }
        public void UPDATEBRANCH(string ActiveCallvalue)
        {
            if (!string.IsNullOrEmpty(Session["UserId"] as string))
            {
                Useridvalue = Session["UserId"].ToString();
                QueryCurr_Select = "Update portaldb.usermaster set ActiveValue='" + ActiveCallvalue + "' where Userid=" + Useridvalue + "";
                S = ObjMain.ExecuteNonQuery(QueryCurr_Select);
            }
            else
            {
                Response.Redirect("Login.aspx");

            }

        }


        protected void btnGetReports_Click(object sender, EventArgs e)
        {
        }

        protected void cmbBranches_SelectedIndexChanged(object sender, EventArgs e)
        {

            System.Threading.Thread.Sleep(1000);
            if (cmbBranches.SelectedIndex == 0)
            {
                Response.Redirect("CategoryCustomize.aspx");
            }
            else
            {
                DT = ObjUserBL.GetPageRightsDetailsPIDNew(Session["UserId"].ToString(), PID, cmbBranches.SelectedItem.Value);
                if (DT.Rows.Count > 0)
                {
                    Page_Acess = DT.Rows[0]["Acess_status"].ToString();
                    Read_Acess = DT.Rows[0]["Read_Access"].ToString();
                    Write_Acess = DT.Rows[0]["Write_Access"].ToString();
                    Isdowld_Acess = DT.Rows[0]["IDwld_Access"].ToString();

                    Session["Page_Acess"] = Page_Acess;
                    Session["Read_Acess"] = Read_Acess;
                    Session["Write_Acess"] = Write_Acess;
                    Session["Isdowld_Acess_7"] = Isdowld_Acess;
                }

                ISHQ = ObjMain.ExecuteScalar("select BranchName from branches where Branchname='" + ActiveCallvalue + "' and branchID=1;");  //now 

                if (ISHQ != "")
                {
                    ActiveCallvalue = ObjSel.GetFirstBranch(Session["Branch_HQ"].ToString());
                    UPDATEBRANCH(ActiveCallvalue);
                }
                else
                {
                    BranchFullName = cmbBranches.SelectedItem.Text;    // This will Return Branch FullName 
                    Cmb_BranchName = ObjUserBL.GetBranchRealValue(Session["Branch_HQ"].ToString(), Session["UserId"].ToString(), BranchFullName);  // This will Return BranchName( Actual Database Name )
                    Rcd_id = ObjMain.ExecuteScalar("select cd_id from portaldb.companydetails where cd_branchid=" + cmbBranches.SelectedItem.Value + " and cd_branchalias='" + Cmb_BranchName + "';");
                    RPortalid = ObjMain.ExecuteScalar("select portaltypeid  from portaldb.invoicedetails where cd_id=" + Rcd_id + ";");
                    DtLicense = ObjUserBL.GetLicenseDetails(RPortalid);

                }

                if (DtLicense.Rows.Count > 0)
                {
                    L_LandingCustomize = DtLicense.Rows[0]["LANDINGCUSTOMIZE"].ToString();
                    Session["L_LandingCustomize"] = L_LandingCustomize;
                }

                if (Session["L_LandingCustomize"].ToString() == "N" || Session["Page_Acess"].ToString() == "N")
                {
                    Response.Redirect("DeniedPage.aspx");
                }
                else
                {
                   // LoadCategoryGrid(Cmb_BranchName);

                }

            }

            // Update the current Branch Selection in db
            UPDATEBRANCH(Cmb_BranchName);





        }
        protected void btnSave_Click(object sender, EventArgs e)
        {

            SaveImage();
        }



        public void SaveImage()
        {

            IISAppName = ObjSel.Get_IISAppName(Session["CM_ID"].ToString(), cmbBranches.SelectedValue);   // Getting IISAppName  
            try
            {

               if (cmbBranches.Visible == true)
                {
                    BranchFullName = cmbBranches.SelectedItem.Text;            // This will Return Branch FullName 
                    Cmb_BranchName = ObjUserBL.GetBranchRealValue(Session["Branch_HQ"].ToString(), Session["UserId"].ToString(), BranchFullName);  // This will Return BranchName( Actual Database Name )

                }
                else
                {
                    Cmb_BranchName = Session["Branch_HQ"].ToString();
                }

                if (IISAppName != "")
                {
                    string path = @"C:/inetpub/wwwroot/OLAPPS/" + IISAppName.ToString().Trim() + "/WebImage/Landing";           // OLOrder  is Application Name ( Need to Pass From UI In future ) 
                    //string ChkPath = Path.Combine(path, Cmb_BranchName);
                    if (!Directory.Exists(path))
                    {
                        Directory.CreateDirectory(path);

                    }
                }
                else
                {
                    string path = @"C:/inetpub/wwwroot/OLOrder/WebImage/Landing";                                              // OLOrder  is Application Name ( Need to Pass From UI In future ) 
                    //string ChkPath = Path.Combine(path, Cmb_BranchName);
                    if (!Directory.Exists(path))
                    {
                        Directory.CreateDirectory(path);                                                                       // If No Directory it will Create  

                    }
                }



                if (FileploadLogo.HasFile)
                {
                    if (IISAppName != "")
                    {
                        SPath = @"C:/inetpub/wwwroot/OLAPPS/" + IISAppName.ToString().Trim() + "/WebImage/Landing";


                    }
                    else
                    {
                        SPath = @"C:/inetpub/wwwroot/OLOrder/WebImage/Landing";
                    }


                    // Image Saving Part 

                  
                    //Path.Combine(str_uploadpath, fileName);  Test
                    string str = FileploadLogo.FileName;
                    string extension = System.IO.Path.GetExtension(FileploadLogo.PostedFile.FileName);
                    string FullExt = "~/" + SPath + "/" + ObjPL.BarCode.ToString().Trim() + extension.ToString();
                    string FinalFullExt = Path.Combine(SPath, "Logo" + extension.ToString());

                    
                    FileploadLogo.PostedFile.SaveAs(FinalFullExt);
                    string SPathnew = "WebImage/Landing";
                    ObjPL.ImgPath = "~/" + SPathnew + "/" + "Logo" + extension.ToString();
                    string Ins_LogoPic = "Insert into    " + Session["Branch_HQ"].ToString() + ".LandingCustomize(BranchAlias, LogoPath) values('" + Session["Branch_HQ"].ToString() + "' ,'" + ObjPL.ImgPath + "' )   ";
                    K = ObjMain.ExecuteNonQuery(Ins_LogoPic);
                         


                }
                
                

                 
                /*

                ObjPL.BarCode = ObjMain.ExecuteScalar("select barcode from  " + Cmb_BranchName + ".inventory where Inventoryid=" + txtReadInventroyId.Text.ToString().Trim() + "");
                if (Fileploadid.HasFile)
                {
                    if (IISAppName != "")
                    {
                        SPath = @"C:/inetpub/wwwroot/OLAPPS/" + IISAppName.ToString().Trim() + "/WebImage/" + Cmb_BranchName;


                    }
                    else
                    {
                        SPath = @"C:/inetpub/wwwroot/OLOrder/WebImage/" + Cmb_BranchName;




                    }


                    // Checking Image Path : if exist it will Delete already saved Image : Insert new one 

                    ChkImagePath = ObjMain.ExecuteScalar("select SUBSTR(Imagepath,2) from " + Cmb_BranchName + ".inventory where inventoryid=" + txtReadInventroyId.Text.ToString().Trim() + "");
                    if (ChkImagePath != "")
                    {

                        if (IISAppName != "")
                        {

                            string PicPath = @"C:/inetpub/wwwroot/OLAPPS/" + IISAppName.ToString().Trim() + " " + ChkImagePath + "  ";

                            if (File.Exists(PicPath))
                            {
                                File.Delete(PicPath);

                            }

                        }
                        else
                        {

                            string PicPath = @"C:/inetpub/wwwroot/OLOrder " + ChkImagePath + "  ";

                            if (File.Exists(PicPath))
                            {
                                File.Delete(PicPath);

                            }

                        }
                    }




                    //Path.Combine(str_uploadpath, fileName);  Test
                    string str = Fileploadid.FileName;
                    string extension = System.IO.Path.GetExtension(Fileploadid.PostedFile.FileName);
                    string FullExt = "~/" + SPath + "/" + ObjPL.BarCode.ToString().Trim() + extension.ToString();
                    string FinalFullExt = Path.Combine(SPath, ObjPL.BarCode.ToString().Trim() + extension.ToString());

                    //Fileploadid.PostedFile.SaveAs(Server.MapPath("~/" + SPath + "/" + ObjPL.BarCode.ToString().Trim() + extension));   // Old  Code
                    Fileploadid.PostedFile.SaveAs(FinalFullExt);
                    string SPathnew = "WebImage/" + Cmb_BranchName;
                    ObjPL.ImgPath = "~/" + SPathnew + "/" + ObjPL.BarCode.ToString().Trim() + extension;
                    string Qry2 = " UPDATE " + Cmb_BranchName + ".inventory SET   ImagePath='" + ObjPL.ImgPath + "' WHERE  Inventoryid=" + txtReadInventroyId.Text.ToString().Trim() + " ";
                    L = ObjMain.ExecuteNonQuery(Qry2);
                }
                else
                {
                    ScriptManager.RegisterStartupScript(Page, Page.GetType(), "err_msg", "alert('Provide the Image For the Product ! ')", true);
                }

                */







            }
            catch (Exception Ex)
            {
                ObjError.Write(Ex);
            }


        }


   }
}